=== srsenb/hdr/CMakeLists.txt ===

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/version.h.in
    ${PROJECT_BINARY_DIR}/version.h
)
