=== srsenb/test/CMakeLists.txt ===

add_subdirectory(mac)
add_subdirectory(upper)
