=== debian/changelog ===
srslte (18.06.1-9build1) hirsute; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 12 Dec 2020 13:20:22 +0100

srslte (18.06.1-9) unstable; urgency=medium

  [ Peter Michael Green ]
  * Add patches to fix build with libbladerf2 and uhd 3.14 (Closes: #940131)
  * Bump build-dependencies on libbladerf-dev and libuhd-dev
    because aforementioned patches will break build with
    older versions.

  [ Ruben Undheim ]
  * Thanks Peter Michael Green !
  * Use debhelper-compat
  * Set DH level to 12
  * New standards version 4.5.0 - no changes

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sun, 22 Mar 2020 10:05:35 +0100

srslte (18.06.1-8) unstable; urgency=medium

  * debian/rules:
    - Only run test suite on some architectures
  * debian/srsepc.install:
    - Also install /usr/bin/srsmbms in 'srsepc'

 -- Ruben Undheim <ruben.undheim@gmail.com>  Mon, 03 Dec 2018 19:21:47 +0100

srslte (18.06.1-7) unstable; urgency=medium

  * Split srslte into multiple binary packages since there are several
    daemons:
    - srsenb
    - srsue
    - srsepc
    - srslte-core
  * srslte-dev depends on srslte-core:any
  * srslte binary package changed to arch=all and binNMU-safe dependencies
    added
  * Move man pages to section 8.
  * debian/rules:
    - Change override_dh_install to override_dh_install-arch
    - Separate build targets for -indep and -arch to make all-build faster
    - Enable test suite for non-SIMD builds

 -- Ruben Undheim <ruben.undheim@gmail.com>  Wed, 28 Nov 2018 19:48:50 +0100

srslte (18.06.1-6) unstable; urgency=medium

  * debian/control:
    - srslte-dev set to "Multi-Arch: same"
    - srslte set to "Multi-Arch: allowed"
    - Dependency on srslte for srslte-dev changed to "srslte:any"
  * debian/rules:
    - Include FMA extension for AVX2 build
    - Clean up properly in override_dh_auto_clean
    - Tidy up commands a bit
    - Disable build of Neon for ARM since it fails to build from source
    - Workaround to get custom cmake invocations to pick up hardening flags
  * d/patches/0007-Option-for-disabling-NEON-on-arm.patch:
    - Fix typo in patch
  * debian/script/srsenb: Start command with "exec"
  * debian/script/srsue: Start command with "exec"
  * debian/tests:
    - Added autopkgtest for srslte checking that all the commands can run

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sat, 24 Nov 2018 10:58:57 +0100

srslte (18.06.1-5) unstable; urgency=medium

  * debian/control:
    - Added more build-dependencies
  * debian/rules:
    - Build separate executables for CPUs with AVX2 extensions, and CPUs
      with SSE4.2 but no AVX extension.
    - Print which version is chosen when starting.
    - Add '-q' to grep invocation

 -- Ruben Undheim <ruben.undheim@gmail.com>  Fri, 23 Nov 2018 18:35:40 +0100

srslte (18.06.1-4) unstable; urgency=medium

  * debian/rules:
    - Build one version with AVX SIMD support for Intel CPUs and one version
      with NEON SIMD support for Arm CPUs.
  * debian/script/srsenb and debian/script/srsue:
    - Scripts which first check if avx2 or neon is available on the machine
      before choosing which executable to start.
  * Restructured patches a bit:
    - 0004-Disable-architecture-specific-SIMD-optimisations.patch removed
    - New patches:
      - 0005-Check-whether-code-compiles-instead-of-whether-it-ru.patch
      - 0005-Patch-for-setting-custom-RPATH.patch
      - 0006-No-native-in-build.patch
      - 0007-Option-for-disabling-NEON-on-arm.patch

 -- Ruben Undheim <ruben.undheim@gmail.com>  Fri, 23 Nov 2018 08:55:21 +0100

srslte (18.06.1-3) unstable; urgency=medium

  * Install systemd service files for the 3 services:
    - srsenb.service
    - srsue.service
    - srsepc.service
  * Install default configuration in /etc/srslte/:
    - drb.conf
    - enb.conf
    - epc.conf
    - mbms.conf
    - rr.conf
    - sib.conf
    - ue.conf
    - user_db.csv
  * debian/rules:
    - Do not enable or start services by default

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sun, 18 Nov 2018 10:52:08 +0100

srslte (18.06.1-2) unstable; urgency=medium

  * d/patches/0004-Disable-architecture-specific-SIMD-optimisations.patch
    - For fixing FTBFS on multiple architectures

 -- Ruben Undheim <ruben.undheim@gmail.com>  Fri, 05 Oct 2018 00:45:17 +0200

srslte (18.06.1-1) unstable; urgency=low

  * Initial release (Closes: #904221)

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sun, 02 Sep 2018 22:56:55 +0200
