=== debian/control ===
Source: srslte
Section: net
Priority: optional
Maintainer: Debian Mobcom Maintainers <Debian-mobcom-maintainers@lists.alioth.debian.org>
Uploaders: Ruben Undheim <ruben.undheim@gmail.com>
Build-Depends: debhelper-compat (= 12),
               cmake,
               libfftw3-dev,
               libmbedtls-dev,
               libboost-program-options-dev,
               libconfig++-dev,
               libsctp-dev,
               libuhd-dev (>= 3.14),
               uhd-host,
               txt2man,
               libpcsclite-dev,
               libbladerf-dev (>= 0.2019.07),
               libsoapysdr-dev
Standards-Version: 4.5.0
Homepage: http://www.softwareradiosystems.com
Vcs-Git: https://salsa.debian.org/debian-mobcom-team/srslte.git
Vcs-Browser: https://salsa.debian.org/debian-mobcom-team/srslte

Package: srslte-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         srslte-core:any (= ${binary:Version})
Description: Static libraries and headers for srslte
 This software allows you to run a full end-to-end, open-source LTE system.
 It contains a UE, eNB and EPC implementation.
 .
 This package contains the development files - static libraries and headers

Package: srslte
Architecture: all
Depends: ${shlibs:Depends},
         ${misc:Depends},
         srsenb       (>= ${source:Version}), srsenb (<< ${source:Upstream-Version}.0~),
         srsue        (>= ${source:Version}), srsue  (<< ${source:Upstream-Version}.0~),
         srsepc       (>= ${source:Version}), srsepc (<< ${source:Upstream-Version}.0~)
Suggests: nextepc
Description: LTE software suite for software defined radios (metapackage)
 This software enables running a full end-to-end, open-source LTE system. It
 contains a UE, eNB and EPC implementation.
 .
 For running a full network, also an implementation of the Evolved Packet Core
 (EPC) is needed.

Package: srsenb
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         srslte-core (= ${binary:Version})
Suggests: nextepc
Breaks: srslte (<< 18.06.1-7)
Replaces: srslte (<< 18.06.1-7)
Description: Evolved Node B in LTE network for Software Defined Radios
 This software enables running a "base-station" for an LTE network.
 .
 For running a full network, also an implementation of the Evolved Packet Core
 (EPC) is needed. (such as nextepc)
 .
 It contains the evolved Node B (eNB) component of the network.

Package: srsue
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         srslte-core (= ${binary:Version})
Breaks: srslte (<< 18.06.1-7)
Replaces: srslte (<< 18.06.1-7)
Description: User Equipment implementation for LTE
 This software enables using a software defined radio as the user equipment
 connecting to an LTE network.
 .
 srsue provides a complete SDR LTE UE application featuring all layers from PHY
 to IP.
 .
 For running an LTE network, 'srsenb' should be used instead.

Package: srsepc
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         srslte-core (= ${binary:Version})
Recommends: srsenb
Breaks: srslte (<< 18.06.1-7)
Replaces: srslte (<< 18.06.1-7)
Description: Light-weight LTE core network implementation
 Together with 'srsenb', this software opens up the possibility to run an LTE
 network using a software defined radio.
 .
 It is a lightweight alternative to tools such as nextepc.

Package: srslte-core
Architecture: any
Multi-Arch: allowed
Depends: ${shlibs:Depends},
         ${misc:Depends}
Breaks: srslte (<< 18.06.1-7)
Replaces: srslte (<< 18.06.1-7)
Description: Common files for srsLTE
 This software enables running a full end-to-end, open-source LTE system. It
 contains a UE, eNB and EPC implementation.
 .
 For running a full network, also an implementation of the Evolved Packet Core
 (EPC) is needed.
 .
 This package contains the common files for srsenb, srsue and srsepc.
