=== debian/tests/control ===
Tests: srsenb-help, srsue-help, srsepc-help
Depends: srslte
